function [ xdata ] = F1_k2x( kdata, dim ,len, dontShift)
    if nargin < 2 || isempty(dim)
        dim = 1;
    end
    
    if nargin < 3 || isempty(len)
        len = size(kdata,dim);
    end

    if nargin < 4
        dontShift = false;
    end
    
    if nargin <3
        if dontShift
            xdata = ifft(kdata,[],dim)*sqrt(size(kdata,dim));
        else
            xdata = fftshift(ifft(ifftshift(kdata,dim),[],dim),dim)*sqrt(size(kdata,dim));
        end
    else
        if dontShift
            xdata = ifft(kdata,len,dim)*sqrt(len);
        else
            xdata = fftshift(ifft(ifftshift(kdata,dim),len,dim),dim)*sqrt(len);
        end
    end
    return;
end
