function [ kdata ] = F1_x2k( xdata, dim , len, dontShift )
    if nargin < 2 || isempty(dim)
        dim = 1;
    end
    
    if nargin < 3 || isempty(len)
        len = size(xdata,dim);
    end

    if nargin < 4
        dontShift = false;
    end
    
    if nargin <3
        if dontShift
            kdata = fft(xdata,[],dim)/sqrt(size(xdata,dim));
        else
            kdata = fftshift(fft(ifftshift(xdata,dim),[],dim),dim)/sqrt(size(xdata,dim));
        end
    else
        if dontShift
            kdata = fft(xdata,len,dim)/sqrt(len);
        else
            kdata = fftshift(fft(ifftshift(xdata,dim),len,dim),dim)/sqrt(len);
        end
    end
    
    return;
end