function create_dicomattrs( )
%CREATE_DICOMATTRS Summary of this function goes here
%   Detailed explanation goes here

[STR, NAM, EXT] = fileparts(mfilename('fullpath'));
VersionGenFile=fullfile(STR,'versionGen.mat');
target=fullfile(STR,'dicomattrs.m');
create_flag = 0;
look_for_dicomparse = 0;
if ~exist(VersionGenFile)
    create_flag = 1;
else
    load(VersionGenFile,'VersionGen');
    if ~strcmp(VersionGen,getVersionGen())
        warning(['Replacing files generated by Matlab ' VersionGen '.']);
        create_flag = 1;
    end
end
if ~exist(target)
    create_flag = 1;
end

if create_flag
    warning(['Creating ' target ])
    source=fullfile(matlabroot,'toolbox','images','iptformats','dicominfo.m');
    fileID=fopen(source);T=textscan(fileID,'%s','Delimiter', '\n'); fclose(fileID);
    T1=regexprep(T{1},'^[ \t]*metadata = ', '%metadata = ');
    T2=regexprep(T1,'^[ \t]*[metadata,attrNames', ['metadata = attrs;\n%[metadata,attrNames']);
    T3=regexprep(T2,'^[ \t]*pixelDataField = ', 'pixelDataField = '''';%');
    % dicomparse mex no longer present in R2019b
    % this is assumed to be the case when the _dicomparse string is found
    % in dicominfo.m
    look_for_dicomparse = isempty(find(~cellfun(@isempty,regexp(T{1},'_dicomparse'))));
    fileID = fopen(target,'w'); fprintf(fileID,'%s\n',T3{:}); fclose(fileID);
    extrafiles={'dicom_findActualFilename.m','dicom_getFileDetails.m'};
    for j=1:length(extrafiles)
        fullf=fullfile(matlabroot,'toolbox','images','iptformats','private',extrafiles{j});
        targf=fullfile(STR,extrafiles{j});
        if 2==exist(fullf)
            warning(['Creating ' targf])
            if 2==exist(targf)
                warning(['Removing old version']);
                delete(targf);
            end
            copyfile(fullf,targf)
        end
    end
    VersionGen=getVersionGen();
    save(VersionGenFile,'VersionGen');
%     extraidx=zeros(size(extrafiles));
%     for i=1:length(T3)
%         for j=1:length(extrafiles)
%             if ~isempty(regexp(T3{i},extrafiles{j}))
%                 extraidx(j)=1
%             end
%         end
%     end
%     for j=find(extraidx)
%         disp(extrafiles(j))
%     end
end

if look_for_dicomparse
    target2 = fullfile(STR,['dicomparse.',mexext]);
    if 3 ~= exist(target2)
        warning(['Creating ' target2 ])
        source=fullfile(matlabroot,'toolbox','images','iptformats','private',['dicomparse.',mexext]);
        if 3 ~= exist(source)
            % new directory in e.g. R2018a
            source=fullfile(matlabroot,'toolbox','images','iptformats','+images','+internal','+dicom',['dicomparse.',mexext]);
            if 3 ~= exist(source)
                error(['Mex file ' source ' not found. Exiting.'])
            end
        end
        copyfile(source,target2)
    end
end

    function str = getVersionGen()
       str = [ computer '_' version('-release') ]; 
    end

end

