function dxt_corr = conjugatePhase3D(sxt,fm_hz,tvec)
    if(length(tvec)~=size(sxt,4))
        error('Number of time points and number of x-t data echoes inconsistent!');
    end
    if ndims(fm_hz)>3 && size(fm_hz,4) == size(sxt,5)
        fm_hz = permute(fm_hz,[1,2,3,5,4]);
    end
    dataSize = size(sxt);
    if isscalar(fm_hz)
        fm_hz = fm_hz*ones(size(sxt(:,:,:,1),1:3));
    end
    if(~all( size(sxt(:,:,:,1)) == size(fm_hz)) )
        oldDims = size(sxt(:,:,:,1));
        newDims = max(size(sxt(:,:,:,1)),size(fm_hz));
        fm_hz   = imresize3d(fm_hz,newDims);
        if ~all(size(sxt(:,:,:,1)) == newDims)
            sxt = imresize_ktrunc(sxt,newDims,false,false);
        end
    end
    phase_term  = bsxfun(@times,fm_hz,reshape(tvec,1,1,1,[]));
    dxt_corr    = bsxfun(@times,sxt,exp(-1i*2*pi*phase_term));
    if exist('newDims','var')
        if ~all(size(dxt_corr(:,:,:,1))==oldDims)
            dxt_corr = imresize_ktrunc(dxt_corr,oldDims,false,false);
        end
    end
    dxt_corr    = reshape(dxt_corr,dataSize);
end

